local K, C = unpack(KkthnxUI)

local function Priority(priorityOverride)
	return {
		enable = true,
		priority = priorityOverride or 0,
		stackThreshold = 0,
	}
end

-- Raid Debuffs
C.DebuffsTracking_PvE = {
	type = "Whitelist",
	spells = {
		-- Death Knight
		[55741] = Priority(1), -- Desecration
		[47481] = Priority(2), -- Gnaw (Ghoul)
		[49203] = Priority(3), -- Hungering Cold
		[47476] = Priority(2), -- Strangulate
		[53534] = Priority(2), -- Chains of Ice
		-- Druid
		[339] = Priority(1), -- Entangling Roots (Rank 1)
		[1062] = Priority(1), -- Entangling Roots (Rank 2)
		[5195] = Priority(1), -- Entangling Roots (Rank 3)
		[5196] = Priority(1), -- Entangling Roots (Rank 4)
		[9852] = Priority(1), -- Entangling Roots (Rank 5)
		[9853] = Priority(1), -- Entangling Roots (Rank 6)
		[26989] = Priority(1), -- Entangling Roots (Rank 7)
		[53308] = Priority(1), -- Entangling Roots (Rank 8)
		[19975] = Priority(1), -- Entangling Roots (Nature's Grasp) (Rank 1)
		[19974] = Priority(1), -- Entangling Roots (Nature's Grasp) (Rank 2)
		[19973] = Priority(1), -- Entangling Roots (Nature's Grasp) (Rank 3)
		[19972] = Priority(1), -- Entangling Roots (Nature's Grasp) (Rank 4)
		[19971] = Priority(1), -- Entangling Roots (Nature's Grasp) (Rank 5)
		[19970] = Priority(1), -- Entangling Roots (Nature's Grasp) (Rank 6)
		[27010] = Priority(1), -- Entangling Roots (Nature's Grasp) (Rank 7)
		[53313] = Priority(1), -- Entangling Roots (Nature's Grasp) (Rank 8)
		[2637] = Priority(1), -- Hibernate (Rank 1)
		[18657] = Priority(1), -- Hibernate (Rank 2)
		[18658] = Priority(1), -- Hibernate (Rank 3)
		[45334] = Priority(2), -- Feral Charge Effect
		[5211] = Priority(4), -- Bash (Rank 1)
		[6798] = Priority(4), -- Bash (Rank 2)
		[8983] = Priority(4), -- Bash (Rank 3)
		[16922] = Priority(2), -- Celestial Focus (Starfire Stun)
		[9005] = Priority(2), -- Pounce (Rank 1)
		[9823] = Priority(2), -- Pounce (Rank 2)
		[9827] = Priority(2), -- Pounce (Rank 3)
		[27006] = Priority(2), -- Pounce (Rank 4)
		[49803] = Priority(2), -- Pounce (Rank 5)
		[770] = Priority(5), -- Faerie Fire
		[16857] = Priority(5), -- Faerie Fire (Feral)
		[22570] = Priority(4), -- Maim (Rank 1)
		[49802] = Priority(4), -- Maim (Rank 2)
		[33786] = Priority(5), -- Cyclone
		[50259] = Priority(2), -- Dazed (Feral Charge - Cat)
		[61391] = Priority(2), -- Typhoon
		-- Hunter
		[60210] = Priority(3), -- Freezing Arrow Effect
		[3355] = Priority(3), -- Freezing Trap Effect (Rank 1)
		[14308] = Priority(3), -- Freezing Trap Effect (Rank 2)
		[14309] = Priority(3), -- Freezing Trap Effect (Rank 3)
		[13810] = Priority(1), -- Frost Trap Aura
		[19503] = Priority(4), -- Scatter Shot
		[5116] = Priority(2), -- Concussive Shot
		[2974] = Priority(2), -- Wing Clip
		[1513] = Priority(2), -- Scare Beast (Rank 1)
		[14326] = Priority(2), -- Scare Beast (Rank 2)
		[14327] = Priority(2), -- Scare Beast (Rank 3)
		[24394] = Priority(2), -- Intimidation
		[19386] = Priority(2), -- Wyvern Sting (Rank 1)
		[24132] = Priority(2), -- Wyvern Sting (Rank 2)
		[24133] = Priority(2), -- Wyvern Sting (Rank 3)
		[27068] = Priority(2), -- Wyvern Sting (Rank 4)
		[49011] = Priority(2), -- Wyvern Sting (Rank 5)
		[49012] = Priority(2), -- Wyvern Sting (Rank 6)
		[19229] = Priority(2), -- Improved Wing Clip
		[19306] = Priority(2), -- Counterattack (Rank 1)
		[20909] = Priority(2), -- Counterattack (Rank 2)
		[20910] = Priority(2), -- Counterattack (Rank 3)
		[27067] = Priority(2), -- Counterattack (Rank 4)
		[48998] = Priority(2), -- Counterattack (Rank 5)
		[48999] = Priority(2), -- Counterattack (Rank 6)
		[34490] = Priority(2), -- Silencing Shot
		[25999] = Priority(2), -- Charge (Boar)
		[19185] = Priority(1), -- Entrapment
		[53359] = Priority(2), -- Chimera Shot - Scorpid
		[35101] = Priority(2), -- Concussive Barrage
		[61394] = Priority(2), -- Glyph of Freezing Trap
		-- Mage
		[118] = Priority(3), -- Polymorph (Rank 1)
		[12824] = Priority(3), -- Polymorph (Rank 2)
		[12825] = Priority(3), -- Polymorph (Rank 3)
		[12826] = Priority(3), -- Polymorph (Rank 4)
		[28271] = Priority(3), -- Polymorph (Turtle)
		[28272] = Priority(3), -- Polymorph (Pig)
		[59634] = Priority(3), -- Polymorph (Penguin)
		[61305] = Priority(3), -- Polymorph (Black Cat)
		[61721] = Priority(3), -- Polymorph (Rabbit)
		[61780] = Priority(3), -- Polymorph (Turkey)
		[31661] = Priority(3), -- Dragon's Breath (Rank 1)
		[33041] = Priority(3), -- Dragon's Breath (Rank 2)
		[33042] = Priority(3), -- Dragon's Breath (Rank 3)
		[33043] = Priority(3), -- Dragon's Breath (Rank 4)
		[42949] = Priority(3), -- Dragon's Breath (Rank 5)
		[42950] = Priority(3), -- Dragon's Breath (Rank 6)
		[122] = Priority(1), -- Frost Nova (Rank 1)
		[865] = Priority(1), -- Frost Nova (Rank 2)
		[6131] = Priority(1), -- Frost Nova (Rank 3)
		[10230] = Priority(1), -- Frost Nova (Rank 4)
		[27088] = Priority(1), -- Frost Nova (Rank 5)
		[42917] = Priority(1), -- Frost Nova (Rank 6)
		[12494] = Priority(2), -- Frostbite
		[116] = Priority(2), -- Frostbolt (Rank 1)
		[205] = Priority(2), -- Frostbolt (Rank 2)
		[837] = Priority(2), -- Frostbolt (Rank 3)
		[7322] = Priority(2), -- Frostbolt (Rank 4)
		[8406] = Priority(2), -- Frostbolt (Rank 5)
		[8407] = Priority(2), -- Frostbolt (Rank 6)
		[8408] = Priority(2), -- Frostbolt (Rank 7)
		[10179] = Priority(2), -- Frostbolt (Rank 8)
		[10180] = Priority(2), -- Frostbolt (Rank 9)
		[10181] = Priority(2), -- Frostbolt (Rank 10)
		[25304] = Priority(2), -- Frostbolt (Rank 11)
		[27071] = Priority(2), -- Frostbolt (Rank 12)
		[27072] = Priority(2), -- Frostbolt (Rank 13)
		[38697] = Priority(2), -- Frostbolt (Rank 14)
		[42841] = Priority(2), -- Frostbolt (Rank 15)
		[42842] = Priority(2), -- Frostbolt (Rank 16)
		[12355] = Priority(2), -- Impact
		[18469] = Priority(2), -- Silenced - Improved Counterspell
		[33395] = Priority(1), -- Freeze (Water Elemental)
		[64346] = Priority(2), -- Fiery Payback
		[11113] = Priority(2), -- Blast Wave
		[12484] = Priority(2), -- Chilled (Blizzard) (Rank 1)
		[12485] = Priority(2), -- Chilled (Blizzard) (Rank 2)
		[12486] = Priority(2), -- Chilled (Blizzard) (Rank 3)
		[6136] = Priority(2), -- Chilled (Frost Armor)
		[7321] = Priority(2), -- Chilled (Ice Armor)
		[120] = Priority(2), -- Cone of Cold
		[44572] = Priority(3), -- Deep Freeze
		[64346] = Priority(2), -- Fiery Payback
		[44614] = Priority(2), -- Frostfire Bolt (Rank 1)
		[47610] = Priority(2), -- Frostfire Bolt (Rank 2)
		[31589] = Priority(2), -- Slow
		-- Paladin
		[853] = Priority(3), -- Hammer of Justice (Rank 1)
		[5588] = Priority(3), -- Hammer of Justice (Rank 2)
		[5589] = Priority(3), -- Hammer of Justice (Rank 3)
		[10308] = Priority(3), -- Hammer of Justice (Rank 4)
		[20066] = Priority(3), -- Repentance
		[20170] = Priority(2), -- Stun (Seal of Justice Proc)
		[10326] = Priority(3), -- Turn Evil
		[63529] = Priority(2), -- Silenced - Shield of the Templar
		[31935] = Priority(2), -- Avenger's Shield
		-- Priest
		[8122] = Priority(3), -- Psychic Scream (Rank 1)
		[8124] = Priority(3), -- Psychic Scream (Rank 2)
		[10888] = Priority(3), -- Psychic Scream (Rank 3)
		[10890] = Priority(3), -- Psychic Scream (Rank 4)
		[605] = Priority(5), -- Mind Control
		[15269] = Priority(2), -- Blackout
		[15407] = Priority(2), -- Mind Flay (Rank 1)
		[17311] = Priority(2), -- Mind Flay (Rank 2)
		[17312] = Priority(2), -- Mind Flay (Rank 3)
		[17313] = Priority(2), -- Mind Flay (Rank 4)
		[17314] = Priority(2), -- Mind Flay (Rank 5)
		[18807] = Priority(2), -- Mind Flay (Rank 6)
		[25387] = Priority(2), -- Mind Flay (Rank 7)
		[48155] = Priority(2), -- Mind Flay (Rank 8)
		[48156] = Priority(2), -- Mind Flay (Rank 9)
		[9484] = Priority(3), -- Shackle Undead (Rank 1)
		[9485] = Priority(3), -- Shackle Undead (Rank 2)
		[10955] = Priority(3), -- Shackle Undead (Rank 3)
		[64044] = Priority(1), -- Psychic Horror
		[64058] = Priority(1), -- Psychic Horror (Disarm)
		[15487] = Priority(2), -- Silence
		-- Rogue
		[6770] = Priority(4), -- Sap (Rank 1)
		[2070] = Priority(4), -- Sap (Rank 2)
		[11297] = Priority(4), -- Sap (Rank 3)
		[51724] = Priority(4), -- Sap (Rank 4)
		[2094] = Priority(5), -- Blind
		[408] = Priority(4), -- Kidney Shot (Rank 1)
		[8643] = Priority(4), -- Kidney Shot (Rank 2)
		[1833] = Priority(2), -- Cheap Shot
		[1776] = Priority(2), -- Gouge (Rank 1)
		[1777] = Priority(2), -- Gouge (Rank 2)
		[8629] = Priority(2), -- Gouge (Rank 3)
		[11285] = Priority(2), -- Gouge (Rank 4)
		[11286] = Priority(2), -- Gouge (Rank 5)
		[38764] = Priority(2), -- Gouge (Rank 6)
		[1330] = Priority(2), -- Garrote - Silence
		[18425] = Priority(2), -- Silenced - Improved Kick
		[51722] = Priority(2), -- Dismantle
		[31125] = Priority(2), -- Blade Twisting (Rank 1)
		[51585] = Priority(2), -- Blade Twisting (Rank 2)
		[3409] = Priority(2), -- Crippling Poison
		[26679] = Priority(2), -- Deadly Throw
		[32747] = Priority(2), -- Interrupt (Deadly Throw)
		[51693] = Priority(2), -- Waylay
		-- Shaman
		[2484] = Priority(1), -- Earthbind Totem
		[8056] = Priority(2), -- Frost Shock (Rank 1)
		[8058] = Priority(2), -- Frost Shock (Rank 2)
		[10472] = Priority(2), -- Frost Shock (Rank 3)
		[10473] = Priority(2), -- Frost Shock (Rank 4)
		[25464] = Priority(2), -- Frost Shock (Rank 5)
		[49235] = Priority(2), -- Frost Shock (Rank 6)
		[49236] = Priority(2), -- Frost Shock (Rank 7)
		[39796] = Priority(2), -- Stoneclaw Totem
		[58861] = Priority(2), -- Bash (Spirit Wolf)
		[51514] = Priority(3), -- Hex
		[8034] = Priority(2), -- Frostbrand Attack (Rank 1)
		[8037] = Priority(2), -- Frostbrand Attack (Rank 2)
		[10458] = Priority(2), -- Frostbrand Attack (Rank 3)
		[16352] = Priority(2), -- Frostbrand Attack (Rank 4)
		[16353] = Priority(2), -- Frostbrand Attack (Rank 5)
		[25501] = Priority(2), -- Frostbrand Attack (Rank 6)
		[58797] = Priority(2), -- Frostbrand Attack (Rank 7)
		[58798] = Priority(2), -- Frostbrand Attack (Rank 8)
		[58799] = Priority(2), -- Frostbrand Attack (Rank 9)
		-- Warlock
		[5782] = Priority(3), -- Fear (Rank 1)
		[6213] = Priority(3), -- Fear (Rank 2)
		[6215] = Priority(3), -- Fear (Rank 3)
		[6358] = Priority(3), -- Seduction (Succubus)
		[18223] = Priority(2), -- Curse of Exhaustion
		[18093] = Priority(2), -- Pyroclasm
		[710] = Priority(2), -- Banish (Rank 1)
		[18647] = Priority(2), -- Banish (Rank 2)
		[30413] = Priority(2), -- Shadowfury
		[6789] = Priority(3), -- Death Coil (Rank 1)
		[17925] = Priority(3), -- Death Coil (Rank 2)
		[17926] = Priority(3), -- Death Coil (Rank 3)
		[27223] = Priority(3), -- Death Coil (Rank 4)
		[5484] = Priority(3), -- Howl of Terror (Rank 1)
		[17928] = Priority(3), -- Howl of Terror (Rank 2)
		[24259] = Priority(2), -- Spell Lock (Felhunter)
		[18118] = Priority(2), -- Aftermath
		[20812] = Priority(2), -- Cripple (Doomguard)
		[60995] = Priority(2), -- Demon Charge (Metamorphosis)
		[1098] = Priority(5), -- Enslave Demon (Rank 1)
		[11725] = Priority(5), -- Enslave Demon (Rank 2)
		[11726] = Priority(5), -- Enslave Demon (Rank 3)
		[61191] = Priority(5), -- Enslave Demon (Rank 4)
		[63311] = Priority(2), -- Glyph of Shadowflame
		[30153] = Priority(2), -- Intercept (Felguard)
		[31117] = Priority(2), -- Unstable Affliction (Silence)
		-- Warrior
		[20511] = Priority(4), -- Intimidating Shout (Cower)
		[5246] = Priority(4), -- Intimidating Shout (Fear)
		[1715] = Priority(2), -- Hamstring
		[12809] = Priority(2), -- Concussion Blow
		[20253] = Priority(2), -- Intercept Stun (Rank 1)
		[20614] = Priority(2), -- Intercept Stun (Rank 2)
		[20615] = Priority(2), -- Intercept Stun (Rank 3)
		[25273] = Priority(2), -- Intercept Stun (Rank 4)
		[25274] = Priority(2), -- Intercept Stun (Rank 5)
		[7386] = Priority(6), -- Sunder Armor
		[7922] = Priority(2), -- Charge Stun
		[18498] = Priority(2), -- Silenced - Gag Order
		[46968] = Priority(3), -- Shockwave
		[23694] = Priority(2), -- Improved Hamstring
		[58373] = Priority(2), -- Glyph of Hamstring
		[676] = Priority(2), -- Disarm
		[12323] = Priority(2), -- Piercing Howl
		-- Racial
		[20549] = Priority(2), -- War Stomp
		[28730] = Priority(2), -- Arcane Torrent (Mana)
		[25046] = Priority(2), -- Arcane Torrent (Energy)
		[50613] = Priority(2), -- Arcane Torrent (Runic Power)
	},
}

-- Dispell Debuffs
C.DebuffsTracking_PvP = {
	type = "Whitelist",
	spells = {
		-- Death Knight
		[48707] = Priority(), -- Anti-Magic Shell
		[51052] = Priority(), -- Anti-Magic Zone
		[49222] = Priority(), -- Bone Shield
		[49028] = Priority(), -- Dancing Rune Weapon
		[49796] = Priority(), -- Deathchill
		[63560] = Priority(), -- Ghoul Frenzy (Ghoul)
		[48792] = Priority(), -- Icebound Fortitude
		[49039] = Priority(), -- Lichborne
		[61777] = Priority(), -- Summon Gargoyle
		[51271] = Priority(), -- Unbreakable Armor
		[55233] = Priority(), -- Vampiric Blood
		-- Druid
		[29166] = Priority(), -- Innervate
		[22812] = Priority(), -- Barkskin
		[17116] = Priority(), -- Nature's Swiftness
		[16689] = Priority(), -- Nature's Grasp (Rank 1)
		[16810] = Priority(), -- Nature's Grasp (Rank 2)
		[16811] = Priority(), -- Nature's Grasp (Rank 3)
		[16812] = Priority(), -- Nature's Grasp (Rank 4)
		[16813] = Priority(), -- Nature's Grasp (Rank 5)
		[17329] = Priority(), -- Nature's Grasp (Rank 6)
		[27009] = Priority(), -- Nature's Grasp (Rank 7)
		[53312] = Priority(), -- Nature's Grasp (Rank 8)
		[16864] = Priority(), -- Omen of Clarity
		[5217] = Priority(), -- Tiger's Fury (Rank 1)
		[6793] = Priority(), -- Tiger's Fury (Rank 2)
		[9845] = Priority(), -- Tiger's Fury (Rank 3)
		[9846] = Priority(), -- Tiger's Fury (Rank 4)
		[50212] = Priority(), -- Tiger's Fury (Rank 5)
		[50213] = Priority(), -- Tiger's Fury (Rank 6)
		[2893] = Priority(), -- Abolish Poison
		[5229] = Priority(), -- Enrage
		[1850] = Priority(), -- Dash (Rank 1)
		[9821] = Priority(), -- Dash (Rank 2)
		[33357] = Priority(), -- Dash (Rank 3)
		[50334] = Priority(), -- Berserk
		[48505] = Priority(), -- Starfall (Rank 1)
		[53199] = Priority(), -- Starfall (Rank 2)
		[53200] = Priority(), -- Starfall (Rank 3)
		[53201] = Priority(), -- Starfall (Rank 4)
		[61336] = Priority(), -- Survival Instincts
		[740] = Priority(), -- Tranquility
		-- Hunter
		[13161] = Priority(), -- Aspect of the Beast
		[5118] = Priority(), -- Aspect of the Cheetah
		[13163] = Priority(), -- Aspect of the Monkey
		[13159] = Priority(), -- Aspect of the Pack
		[20043] = Priority(), -- Aspect of the Wild (Rank 1)
		[20190] = Priority(), -- Aspect of the Wild (Rank 2)
		[27045] = Priority(), -- Aspect of the Wild (Rank 3)
		[49071] = Priority(), -- Aspect of the Wild (Rank 4)
		[3045] = Priority(), -- Rapid Fire
		[19263] = Priority(), -- Deterrence
		[13165] = Priority(), -- Aspect of the Hawk (Rank 1)
		[14318] = Priority(), -- Aspect of the Hawk (Rank 2)
		[14319] = Priority(), -- Aspect of the Hawk (Rank 3)
		[14320] = Priority(), -- Aspect of the Hawk (Rank 4)
		[14321] = Priority(), -- Aspect of the Hawk (Rank 5)
		[14322] = Priority(), -- Aspect of the Hawk (Rank 6)
		[25296] = Priority(), -- Aspect of the Hawk (Rank 7)
		[27044] = Priority(), -- Aspect of the Hawk (Rank 8)
		[19574] = Priority(), -- Bestial Wrath
		[35098] = Priority(), -- Rapid Killing
		[34471] = Priority(), -- The Beast Within
		-- Mage
		[45438] = Priority(), -- Ice Block
		[12043] = Priority(), -- Presence of Mind
		[28682] = Priority(), -- Combustion
		[12042] = Priority(), -- Arcane Power
		[11426] = Priority(), -- Ice Barrier (Rank 1)
		[13031] = Priority(), -- Ice Barrier (Rank 2)
		[13032] = Priority(), -- Ice Barrier (Rank 3)
		[13033] = Priority(), -- Ice Barrier (Rank 4)
		[27134] = Priority(), -- Ice Barrier (Rank 5)
		[33405] = Priority(), -- Ice Barrier (Rank 6)
		[43038] = Priority(), -- Ice Barrier (Rank 7)
		[43039] = Priority(), -- Ice Barrier (Rank 8)
		[12472] = Priority(), -- Icy Veins
		[66] = Priority(), -- Invisibility
		[55342] = Priority(), -- Mirror Image
		-- Paladin
		[1044] = Priority(), -- Hand of Freedom
		[1038] = Priority(), -- Hand of Salvation
		[465] = Priority(), -- Devotion Aura (Rank 1)
		[10290] = Priority(), -- Devotion Aura (Rank 2)
		[643] = Priority(), -- Devotion Aura (Rank 3)
		[10291] = Priority(), -- Devotion Aura (Rank 4)
		[1032] = Priority(), -- Devotion Aura (Rank 5)
		[10292] = Priority(), -- Devotion Aura (Rank 6)
		[10293] = Priority(), -- Devotion Aura (Rank 7)
		[27149] = Priority(), -- Devotion Aura (Rank 8)
		[48941] = Priority(), -- Devotion Aura (Rank 9)
		[48942] = Priority(), -- Devotion Aura (Rank 10)
		[19746] = Priority(), -- Concentration Aura
		[7294] = Priority(), -- Retribution Aura (Rank 1)
		[10298] = Priority(), -- Retribution Aura (Rank 2)
		[10299] = Priority(), -- Retribution Aura (Rank 3)
		[10300] = Priority(), -- Retribution Aura (Rank 4)
		[10301] = Priority(), -- Retribution Aura (Rank 5)
		[27150] = Priority(), -- Retribution Aura (Rank 6)
		[54043] = Priority(), -- Retribution Aura (Rank 7)
		[19876] = Priority(), -- Shadow Resistance Aura (Rank 1)
		[19895] = Priority(), -- Shadow Resistance Aura (Rank 2)
		[19896] = Priority(), -- Shadow Resistance Aura (Rank 3)
		[27151] = Priority(), -- Shadow Resistance Aura (Rank 4)
		[48943] = Priority(), -- Shadow Resistance Aura (Rank 5)
		[19888] = Priority(), -- Frost Resistance Aura (Rank 1)
		[19897] = Priority(), -- Frost Resistance Aura (Rank 2)
		[19898] = Priority(), -- Frost Resistance Aura (Rank 3)
		[27152] = Priority(), -- Frost Resistance Aura (Rank 4)
		[48945] = Priority(), -- Frost Resistance Aura (Rank 5)
		[19891] = Priority(), -- Fire Resistance Aura (Rank 1)
		[19899] = Priority(), -- Fire Resistance Aura (Rank 2)
		[19900] = Priority(), -- Fire Resistance Aura (Rank 3)
		[27153] = Priority(), -- Fire Resistance Aura (Rank 4)
		[27153] = Priority(), -- Fire Resistance Aura (Rank 5)
		[498] = Priority(), -- Divine Protection
		[642] = Priority(), -- Divine Shield
		[1022] = Priority(), -- Hand of Protection (Rank 1)
		[5599] = Priority(), -- Hand of Protection (Rank 2)
		[10278] = Priority(), -- Hand of Protection (Rank 3)
		[31821] = Priority(), -- Aura Mastery
		[70940] = Priority(), -- Divine Guardian
		[64205] = Priority(), -- Divine Sacrifice
		[6940] = Priority(), -- Hand of Sacrifice
		[31884] = Priority(), -- Avenging Wrath
		[20216] = Priority(), -- Divine Favor
		[31842] = Priority(), -- Divine Illumination
		-- Priest
		[15473] = Priority(), -- Shadowform
		[10060] = Priority(), -- Power Infusion
		[14751] = Priority(), -- Inner Focus
		[1706] = Priority(), -- Levitate
		[586] = Priority(), -- Fade
		[64843] = Priority(), -- Divine Hymn
		[47788] = Priority(), -- Guardian Spirit
		[64901] = Priority(), -- Hymn of Hope
		[47585] = Priority(), -- Dispersion
		-- Rogue
		[14177] = Priority(), -- Cold Blood
		[13877] = Priority(), -- Blade Flurry
		[13750] = Priority(), -- Adrenaline Rush
		[2983] = Priority(), -- Sprint (Rank 1)
		[8696] = Priority(), -- Sprint (Rank 2)
		[11305] = Priority(), -- Sprint (Rank 3)
		[5171] = Priority(), -- Slice and Dice (Rank 1)
		[6774] = Priority(), -- Slice and Dice (Rank 2)
		[45182] = Priority(), -- Cheating Death
		[51690] = Priority(), -- Killing Spree
		[51713] = Priority(), -- Shadow Dance
		[57933] = Priority(), -- Tricks of the Trade
		[31224] = Priority(), -- Cloak of Shadows
		[5277] = Priority(), -- Evasion (Rank 1)
		[26669] = Priority(), -- Evasion (Rank 2)
		[1856] = Priority(), -- Vanish (Rank 1)
		[1857] = Priority(), -- Vanish (Rank 2)
		[26889] = Priority(), -- Vanish (Rank 3)
		-- Shaman
		[2645] = Priority(), -- Ghost Wolf
		[324] = Priority(), -- Lightning Shield (Rank 1)
		[325] = Priority(), -- Lightning Shield (Rank 2)
		[905] = Priority(), -- Lightning Shield (Rank 3)
		[945] = Priority(), -- Lightning Shield (Rank 4)
		[8134] = Priority(), -- Lightning Shield (Rank 5)
		[10431] = Priority(), -- Lightning Shield (Rank 6)
		[10432] = Priority(), -- Lightning Shield (Rank 7)
		[25469] = Priority(), -- Lightning Shield (Rank 8)
		[25472] = Priority(), -- Lightning Shield (Rank 9)
		[49280] = Priority(), -- Lightning Shield (Rank 10)
		[49281] = Priority(), -- Lightning Shield (Rank 11)
		[16188] = Priority(), -- Nature's Swiftness
		[16166] = Priority(), -- Elemental Mastery
		[52127] = Priority(), -- Water Shield (Rank 1)
		[52129] = Priority(), -- Water Shield (Rank 2)
		[52131] = Priority(), -- Water Shield (Rank 3)
		[52134] = Priority(), -- Water Shield (Rank 4)
		[52136] = Priority(), -- Water Shield (Rank 5)
		[52138] = Priority(), -- Water Shield (Rank 6)
		[24398] = Priority(), -- Water Shield (Rank 7)
		[33736] = Priority(), -- Water Shield (Rank 8)
		[57960] = Priority(), -- Water Shield (Rank 9)
		[974] = Priority(), -- Earth Shield (Rank 1)
		[32593] = Priority(), -- Earth Shield (Rank 2)
		[32594] = Priority(), -- Earth Shield (Rank 3)
		[49283] = Priority(), -- Earth Shield (Rank 4)
		[49284] = Priority(), -- Earth Shield (Rank 5)
		[30823] = Priority(), -- Shamanistic Rage
		[8178] = Priority(), -- Grounding Totem Effect
		[16191] = Priority(), -- Mana Tide
		[55198] = Priority(), -- Tidal Force
		-- Warlock
		[18789] = Priority(), -- Demonic Sacrifice (Burning Wish)
		[18790] = Priority(), -- Demonic Sacrifice (Fel Stamina)
		[18791] = Priority(), -- Demonic Sacrifice (Touch of Shadow)
		[18792] = Priority(), -- Demonic Sacrifice (Fel Energy)
		[35701] = Priority(), -- Demonic Sacrifice (Touch of Shadow)
		[5697] = Priority(), -- Unending Breath
		[6512] = Priority(), -- Detect Lesser Invisibility
		[25228] = Priority(), -- Soul Link
		[18708] = Priority(), -- Fel Domination
		[47241] = Priority(), -- Metamorphosis
		-- Warrior
		[12975] = Priority(), -- Last Stand
		[871] = Priority(), -- Shield Wall
		[20230] = Priority(), -- Retaliation
		[1719] = Priority(), -- Recklessness
		[18499] = Priority(), -- Berserker Rage
		[2687] = Priority(), -- Bloodrage
		[12292] = Priority(), -- Death Wish
		[12328] = Priority(), -- Sweeping Strikes
		[2565] = Priority(), -- Shield Block
		[12880] = Priority(), -- Enrage (Rank 1)
		[14201] = Priority(), -- Enrage (Rank 2)
		[14202] = Priority(), -- Enrage (Rank 3)
		[14203] = Priority(), -- Enrage (Rank 4)
		[14204] = Priority(), -- Enrage (Rank 5)
		[46924] = Priority(), -- Bladestorm
		[23920] = Priority(), -- Spell Reflection
		-- Consumables
		[3169] = Priority(), -- Limited Invulnerability Potion
		[6615] = Priority(), -- Free Action Potion
		-- Racial
		[26297] = Priority(), -- Berserking
		[7744] = Priority(), -- Will of the Forsaken
		[20572] = Priority(), -- Blood Fury (Physical)
		[33697] = Priority(), -- Blood Fury (Both)
		[33702] = Priority(), -- Blood Fury (Spell)
		[6346] = Priority(), -- Fear Ward
		[20594] = Priority(), -- Stoneform
		[28880] = Priority(), -- Gift of the Naaru
		-- All Classes
		[19753] = Priority(), -- Divine Intervention
	},
}

-- Buffs that really we dont need to see
C.DebuffsTracking_Blacklist = {
	type = "Blacklist",
	spells = {
		[186403] = Priority(), -- Sign of Battle
	},
}
